PageRenderTime 15ms CodeModel.GetById 8ms app.highlight 4ms RepoModel.GetById 1ms app.codeStats 0ms

/crypto/heimdal/tests/kdc/check-kadmin.in

https://bitbucket.org/freebsd/freebsd-head/
Autoconf | 151 lines | 81 code | 30 blank | 40 comment | 12 complexity | 4cd69f32873600b6fc3961aaa278f3f6 MD5 | raw file
  1#!/bin/sh
  2#
  3# Copyright (c) 2006 - 2007 Kungliga Tekniska Högskolan
  4# (Royal Institute of Technology, Stockholm, Sweden). 
  5# All rights reserved. 
  6#
  7# Redistribution and use in source and binary forms, with or without 
  8# modification, are permitted provided that the following conditions 
  9# are met: 
 10#
 11# 1. Redistributions of source code must retain the above copyright 
 12#    notice, this list of conditions and the following disclaimer. 
 13#
 14# 2. Redistributions in binary form must reproduce the above copyright 
 15#    notice, this list of conditions and the following disclaimer in the 
 16#    documentation and/or other materials provided with the distribution. 
 17#
 18# 3. Neither the name of the Institute nor the names of its contributors 
 19#    may be used to endorse or promote products derived from this software 
 20#    without specific prior written permission. 
 21#
 22# THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND 
 23# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 24# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 25# ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE 
 26# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 27# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 28# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 29# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 30# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 31# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 32# SUCH DAMAGE. 
 33#
 34# $Id$
 35#
 36
 37srcdir="@srcdir@"
 38objdir="@objdir@"
 39EGREP="@EGREP@"
 40
 41# If there is no useful db support compile in, disable test
 42../db/have-db || exit 77
 43
 44R=TEST.H5L.SE
 45R2=TEST2.H5L.SE
 46
 47port=@port@
 48admport=@admport@
 49
 50cache="FILE:${objdir}/cache.krb5"
 51
 52kadmin="${TESTS_ENVIRONMENT} ../../kadmin/kadmin -r $R"
 53kdc="${TESTS_ENVIRONMENT} ../../kdc/kdc --addresses=localhost -P $port"
 54kadmind="${TESTS_ENVIRONMENT} ../../kadmin/kadmind -p $admport"
 55
 56server=host/datan.test.h5l.se
 57
 58kinit="${TESTS_ENVIRONMENT} ../../kuser/kinit -c $cache --no-afslog"
 59kgetcred="${TESTS_ENVIRONMENT} ../../kuser/kgetcred -c $cache"
 60kdestroy="${TESTS_ENVIRONMENT} ../../kuser/kdestroy -c $cache --no-unlog"
 61
 62KRB5_CONFIG="${objdir}/krb5.conf"
 63export KRB5_CONFIG
 64
 65rm -f ${keytabfile}
 66rm -f current-db*
 67rm -f out-*
 68rm -f mkey.file*
 69rm -f messages.log
 70
 71> messages.log
 72
 73echo Creating database
 74${kadmin} -l \
 75    init \
 76    --realm-max-ticket-life=1day \
 77    --realm-max-renewable-life=1month \
 78    ${R} || exit 1
 79
 80${kadmin} -l add -p foo --use-defaults foo/admin@${R} || exit 1
 81${kadmin} -l add -p foo --use-defaults bar@${R} || exit 1
 82
 83echo foo > ${objdir}/foopassword
 84
 85echo Starting kdc
 86${kdc} &
 87kdcpid=$!
 88
 89sh ${srcdir}/wait-kdc.sh
 90if [ "$?" != 0 ] ; then
 91    kill ${kdcpid}
 92    kill ${kadmpid}
 93    exit 1
 94fi
 95
 96trap "kill ${kdcpid} ${kadmpid}" EXIT
 97
 98#----------------------------------
 99${kadmind} -d &
100kadmpid=$!
101sleep 1
102
103echo "kinit (no admin)"
104${kinit} --password-file=${objdir}/foopassword \
105    -S kadmin/admin@${R} bar@${R} || exit 1
106echo "kadmin"
107env KRB5CCNAME=${cache} \
108${kadmin} -p bar@${R} add -p foo --use-defaults kaka2@${R} || 
109	{ echo "kadmin failed $?"; cat messages.log ; exit 1; }
110
111${kadmin} -l get kaka2@${R} > /dev/null ||
112	{ echo "kadmin failed $?"; cat messages.log ; exit 1; }
113
114#----------------------------------
115${kadmind} -d &
116kadmpid=$!
117sleep 1
118
119echo "kinit (admin)"
120${kinit} --password-file=${objdir}/foopassword \
121    -S kadmin/admin@${R} foo/admin@${R} || exit 1
122
123echo "kadmin"
124env KRB5CCNAME=${cache} \
125${kadmin} -p foo/admin@${R} add -p foo --use-defaults kaka@${R} || 
126	{ echo "kadmin failed $?"; cat messages.log ; exit 1; }
127
128#----------------------------------
129${kadmind} -d &
130kadmpid=$!
131sleep 1
132
133echo "kadmin get doesnotexists"
134env KRB5CCNAME=${cache} \
135${kadmin} -p foo/admin@${R} get -s doesnotexists@${R} \
136        > /dev/null 2>kadmin.tmp && \
137	{ echo "kadmin passed"; cat messages.log ; exit 1; }
138
139# evil hack to support libtool
140sed 's/lt-kadmin:/kadmin:/' < kadmin.tmp > kadmin2.tmp
141mv kadmin2.tmp kadmin.tmp
142
143cmp kadmin.tmp ${srcdir}/donotexists.txt || \
144    { echo "wrong response"; exit 1;}
145
146echo "killing kdc (${kdcpid} ${kadmpid})"
147kill ${kdcpid} ${kadmpid} > /dev/null 2>/dev/null
148
149trap "" EXIT
150
151exit $ec